
-- Base script for BattleMod character courtesy of Clairebun

-- Pardon my dust, I never modded battlemod before
--											Jon

local loaded = false

// Valid panims to execute our fire breath
local validPanim = {}
validPanim[PA_IDLE] = true	validPanim[PA_EDGE] = true	validPanim[PA_WALK] = true
validPanim[PA_RUN] = true	validPanim[PA_JUMP] = true	validPanim[PA_SPRING] = true
validPanim[PA_ROLL] = true	validPanim[PA_ABILITY2] = true

// Valid states to execute our fire breath
local validStates = {}
validStates[S_PLAY_TRIPFBALL1] = true 	validStates[S_PLAY_TRIPFBALL1_AIR] = true
validStates[S_PLAY_TRIPFBALL2] = true 	validStates[S_PLAY_TRIPFBALL2_AIR] = true

// Function to allows us to spin around outside of automatic mode
local function angtoint(a)
	if not a return 0 end
	a = $/ANG1
	if a < 0
		a = $+360
	end
	return a
end

-- Expect a lot of shoddy code going into this. Trip's been in the backburner so long I ended up mixing
-- different coding methods I started adopting over time and commented very little as I wrote this shit down.
addHook("ThinkFrame", function()

	if not CBW_Battle return end
	if loaded return end

	local B = CBW_Battle

	local FireBreath = function(mo, doaction)
		local p = mo.player
				
		p.actiontext = "Fireball"
		p.actionrings = trip.FIRECOST
		p.action2text = nil
		p.action2rings = 0

		// Movement behavior while in a fireball state
		if validStates[mo.state] or mo.state == S_PLAY_TRIPFBALL3

			p.canguard = 0
			p.pflags = $ & ~PF_JUMPED
			// Allow trip to aim while not in automatic mode
			local diff = mo.angle - p.drawangle
			local factor = 8
			if (diff)
				diff = (angtoint(diff) > 180) and InvAngle(InvAngle(diff)/factor) or $/factor
				p.drawangle = $ + diff
			end
			// If we're grounded stand still. Otherwise strafe about freely
			if not (P_IsObjectOnGround(mo)) then p.pflags = $ & ~(PF_STASIS)
			else
				p.pflags = $|PF_FULLSTASIS
			end
			// We are at full charge. Shake around a bit. This is being reset in the main lua file.
			if p.actiontime == trip.FIRECHARGETIME
				mo.spritexoffset = mo.extravalue1 + P_RandomRange(-3, 3)*FRACUNIT
				local txtblink = (leveltime%6) < 3 and "\x87" or "\x82"
				p.actiontext = txtblink.."Combustion"
			end
		end
		
		// BRUH
		if B.ButtonCheck(p,BT_TOSSFLAG) and B.CanShieldActive(p)
			mo.cusval = p.powers[pw_shield]
		end

		// Keep resetting these two and ending the function here in case we can't do anything fireball-related
		if not (B.CanDoAction(p)) or (p.powers[pw_super])
			p.actionstate = 0
			p.actiontime = 0
			return 
		end
		
		// We executed a command from a valid PANIM. We'll also keep executing this code while in a charging state.
		if (p.actionstate == 0 or p.actionstate == 1) and doaction == 2 
		and (validPanim[p.panim] or validStates[mo.state])

			p.actionstate = 1
			// We entered this block for the first time. Let's do some stuff
			if mo.state ~= S_PLAY_TRIPFBALL1 and mo.state ~= S_PLAY_TRIPFBALL2
			and mo.state ~= S_PLAY_TRIPFBALL1_AIR and mo.state ~= S_PLAY_TRIPFBALL2_AIR
				mo.state = P_IsObjectOnGround(mo) and S_PLAY_TRIPFBALL1 or S_PLAY_TRIPFBALL1_AIR
			end
			// We are charging our fire breath
			if p.actiontime < trip.FIRECHARGETIME
				p.actiontime = $+1
				if p.actiontime == 5 then S_StartSound(mo, sfx_tbrea) end // Adding a small delay here so you don't hear the breathing in when tapping the key
				mo.spritexscale = FRACUNIT - p.actiontime*(FRACUNIT/(trip.FIRECHARGETIME*10))
				mo.spriteyscale = FRACUNIT + p.actiontime*(FRACUNIT/(trip.FIRECHARGETIME*10))
				if p.actiontime == trip.FIRECHARGETIME
					mo.extravalue1 = mo.spritexoffset
					S_StartSound(mo, sfx_tfirea)
					mo.spritexscale = FRACUNIT
					mo.spriteyscale = FRACUNIT
				end
			// We are done charging and already executed our frame-one changes above, so now keep blinking
			else
				mo.state = P_IsObjectOnGround(mo) and S_PLAY_TRIPFBALL2 or S_PLAY_TRIPFBALL2_AIR
				mo.colorized = not (leveltime%5)
			end
			p.action2text = "Charge: \x87 ".. ((p.actiontime*10)/(trip.FIRECHARGETIME/10)) .."%"
		end

		// We released the action key during the charge state! Fire our attack
		if p.actionstate == 1 and doaction == 0 
		and validStates[mo.state]
			// Set some needed stuff
			p.pflags = $ & ~PF_SPINNING
			p.actionstate = 2
			B.PayRings(p, p.actionrings, false)
			mo.state = S_PLAY_TRIPFBALL3
			S_StopSound(mo, sfx_tbrea)
			mo.spritexoffset = 0
			// We didn't charge enough, so spit out a fireball
			if p.actiontime <= trip.FIRECHARGETIME-1
				local fireball = (mo.target and mo.target.valid) and P_SpawnMissile(mo, mo.target, MT_TRIPBALLS) or P_SPMAngle(p.mo, MT_TRIPBALLS, p.mo.angle, 1)
				if fireball and fireball.valid
					fireball.name = "fireball"
					fireball.color = (gametyperules & GTR_TEAMS) and mo.color or SKINCOLOR_APRICOT
					if p.TRP.fireballBoost == nil then p.TRP.fireballBoost = 3 end
					if p.TRP.fireballBoost and not P_IsObjectOnGround(mo)
						P_SetObjectMomZ(mo, (FRACUNIT + FRACUNIT/2) * p.TRP.fireballBoost)
						p.TRP.fireballBoost = $ - 1
					end
					P_Thrust(fireball, fireball.angle, p.speed)
					S_StartSound(mo, sfx_tmari)
					P_SetOrigin(fireball, fireball.x + 5*cos(mo.angle), fireball.y + 5*sin(mo.angle), fireball.z + (7*FRACUNIT*P_MobjFlip(mo)) )
					if fireball.valid
						fireball.scalespeed = FRACUNIT/10
						fireball.origscale = mo.scale
						fireball.scale = mo.scale
						fireball.frame = $|FF_FULLBRIGHT
						p.drawangle = fireball.angle
					end
				end
				p.actionstate = 0
				p.actiontime = 0
				B.ApplyCooldown(p,trip.FIRECOOLDOWN)
			else
				// We have enough charge! Enter a special third action state wherein trip will spit out a fire stream
				p.actiontime = 10
				p.actionstate = 3
				p.TRP.flameTime = 30
				S_StartSoundAtVolume(p.mo, sfx_trftlo, 180)
				B.ApplyCooldown(p,trip.BREATHCOOLDOWN)
			end
			p.action2text = nil
		// We were previously in a charge state, but something went wrong and our state isn't what it should be. Reset some stuff.
		elseif p.actionstate == 1 and doaction == 0 and (mo.state ~= S_PLAY_TRIPFBALL1 or mo.state ~= S_PLAY_TRIPFBALL1_AIR)
			p.actionstate = 0
			p.actiontime = 0
			return
		end

		// The fire breath proper. Create a stream of fire every few tics if we are in the correct state
		if p.actionstate == 3 and p.actiontime
		and (mo.state == S_PLAY_TRIPFBALL3 or p.TRP.lastState == S_PLAY_TRIPFBALL3)
		and not P_PlayerInPain(p)
			mo.state = S_PLAY_TRIPFBALL3 // Let's reinforce this just in case we have a passive state change, like landing from a jump
			if p.actiontime == 10 or p.actiontime == 6 or p.actiontime == 2
				trip.BattleFireBreath(p)
			end
			mo.spritexoffset = 0
			p.actiontime = $-1
			if not p.actiontime
				p.actionstate = 0
			end
		end

		// We spat out a fireball. Wait a few tics then go back to normal
		if p.actionstate == 2
			p.actiontime = $+1
			if p.actiontime == states[S_PLAY_TRIPFBALL1].tics then
				p.actionstate = 0
				p.actiontime = 0
			end
		end

		// We hit the parry button mid-charge, so cancel our charge and start a cooldown
		if B.PlayerButtonPressed(p, p.battleconfig_guard, false) 
		and (p.actionstate == 1 or p.actionstate == 2)
			p.actionstate = 0
			p.actiontime = 0
			p.doaction = 0
			B.ApplyCooldown(p,trip.BREATHCOOLDOWN)
			mo.spritexoffset = 0
			if P_IsObjectOnGround(mo)
				mo.state = p.speed and S_PLAY_WALK or S_PLAY_STND
			else
				mo.state = S_PLAY_FALL
			end
		end
		
		// We parried during a ceiling cling. Reset some stuff.
		if B.PlayerButtonPressed(p, p.battleconfig_guard, false)
		and p.TRP.spikemode 
			trip.RollReturn(p)
			mo.trip_ceilingstick = nil
			p.mo.flags2 = not ($ & MF2_OBJECTFLIP) and $|(MF2_OBJECTFLIP) or $ & ~(MF2_OBJECTFLIP)
			p.mo.eflags = not ($ & MFE_VERTICALFLIP) and $|(MFE_VERTICALFLIP) or $ & ~(MFE_VERTICALFLIP)
		end
	end
	
		
	-- Priority Table
	local TripPrio = function(player)
		local mo = player.mo
		local spinjump = (player.pflags&PF_JUMPED and not(player.pflags&PF_NOJUMPDAMAGE))
		local spinning = (mo.state == S_PLAY_ROLL or mo.state == S_PLAY_TNROLL1 or mo.state == S_PLAY_TNROLL2)
		local spindash = (mo.state == S_PLAY_SPINDASH)
		local clinging = (mo.state == S_PLAY_CLING or mo.state == S_PLAY_CLIMB)
		local ceiling = (mo.state == S_PLAY_TSPIKEROLL)
		local bullshit = false
		if player.TRP
			bullshit = (mo.state == S_PLAY_STND and player.TRP.lastState == S_PLAY_TRSPIKE and mo.state ~= S_PLAY_TRSPIKE)
		end

		if player.actionstate == 1 then
			B.SetPriority(player,0,0,nil,0,0,"Trip Charge")
		elseif player.actionstate == 2 then
			B.SetPriority(player,0,1,nil,0,1,"Trip Charging")
		elseif player.actionstate == 3 or (spinning)
			B.SetPriority(player,1,1,nil,1,1,"Spin Attack")
		elseif spindash
			B.SetPriority(player,1,1,nil,1,1,"Spin Dash")		
		elseif clinging
			B.SetPriority(player,1,1,nil,1,1,"Spin Attack")	
		elseif mo.sprite2 == SPR2_LAND  -- Easter Egg Attack
			B.SetPriority(player,3,3,nil,3,3,"The Legendary Spine Breaker")
		elseif mo.sprite2 == SPR2_SHIT 	
			B.SetPriority(player,0,1,"tails_fly",0,0,"I've Fallen!")
		elseif spinjump or bullshit
			B.SetPriority(player,1,1,nil,1,1,"Spin Attack")
		elseif ceiling
			B.SetPriority(player,1,1,nil,1,1,"Spin Attack")
		elseif mo.state == S_PLAY_TWAIT2 -- Second Phase of Waiting Animation
			B.SetPriority(player,0,1,"stomp",0,0,"Idle")
		end
	end
	
	local function shetripped(player)
		local mo = player.mo
		-- B.ZLaunch(mo, 20 * mo.scale, false)
		player.mo.sprite2 = SPR2_SHIT
		mo.momy = $ * 4/5
		mo.momx = $ * -2/3
		player.canguard = false
		player.actionstate = 0
		player.actiontime = 0
		player.actionsuper = 1
	end

	local function itripped(player)
		if not (player and player.valid and player.playerstate == PST_LIVE)
			or not player.mo
			or not (player.mo.sprite2 == SPR2_LAND or player.mo.sprite2 == SPR2_SHIT)
			or not player.mo.health
			return false
		end
		return true
	end

	B.Trip_PreCollide = function(n1,n2,plr,mo,atk,def,weight,hurt,pain,ground,angle,thrust,thrust2,collisiontype)
	
		if plr[n2] and (plr[n2].dashmode > 3*TICRATE or (plr[n2].blazeboosting and (atk[n2] and atk[n2] == 3)))
		and (plr[n1].battle_sfunc and plr[n1].battle_sfunc == "tails_fly")
			plr[n1].stupidashmodemarker = true
			plr[n2].dashmode = 0*TICRATE
			plr[n2].atk = 0
		end
		
		if (def[n1] == 1) and (atk[n2] > 0) and (plr[n1].battle_sfunc and plr[n1].battle_sfunc == "stomp")
					plr[n1].waitingmarker = true -- Apply Marker For Waiting
				end
				
		if itripped(plr[n1])
				plr[n1].tripmarker = true
		end
	end
	

	B.Trip_PostCollide = function(n1,n2,plr,mo,atk,def,weight,hurt,pain,ground,angle,thrust,thrust2,collisiontype)
		if plr[n1] and plr[n1].tripmarker
			plr[n1].tripmarker = nil
		end
	end

	B.Trip_Collide = function(n1,n2,plr,mo,atk,def,weight,hurt,pain,ground,angle,thrust,thrust2,collisiontype)
		if not (plr[n1] and plr[n1].tripmarker)
			
		if (plr[n1].waitingmarker == true) and (plr[n1].battle_sfunc and plr[n1].battle_sfunc == "stomp") -- If our conditions are met
			B.DoPlayerTumble(plr[n1], 15, mo[n1].angle, FixedHypot(mo[n1].momx, mo[n1].momy), false) -- For anyone tampering this is Trips Idle Tumble
			B.ZLaunch(mo[n1], 7 * mo[n2].scale, false) -- launch
		end
		
		if (plr[n1].stupidashmodemarker == true) and (def[n1] == 1) and (atk[n2] == 3) 
		and (plr[n1].battle_sfunc and plr[n1].battle_sfunc == "tails_fly")
			plr[n1].battle_sdef = 3
			plr[n1].def = 3
			plr[n2].atk = 0
			B.DoPlayerTumble(plr[n2], 60, mo[n2].angle, FixedHypot(mo[n2].momx, mo[n2].momy), false) -- Dashmode Tumble
			B.ZLaunch(mo[n2], 5 * mo[n2].scale, false)
		end
			
			// We got bumped while charging in the air. Cancel our charge with a very brief cooldown.
			if plr[n1].actionstate == 1 and not P_IsObjectOnGround(plr[n1].mo)
				plr[n1].actiontime = 0
				plr[n1].doaction = 0
				B.ApplyCooldown(plr[n1],trip.AIRBUMPCOOLDOWN)
			end
			plr[n1].mo.spritexoffset = 0
			plr[n1].mo.extravalue1 = 0
			return false
		end
		if (hurt != 1 and n1 == 1) or (hurt != -1 and n1 == 2)
			if not (plr[n2] and plr[n2].tripmarker)
				shetripped(plr[n1])
				plr[n1].canguard = false
			end
			
			-- For anyone tampering, the following is Trips fallen easter egg tumble
			if (ground[n2]) 
			and plr[n2] and (def[n1] >= 1) and (plr[n1].battle_sfunc and plr[n1].battle_sfunc == "tails_fly")
			and (atk[n2] == 1) or (atk[n2] == 0)
			and not (plr[n2].tumble and plr[n2].tumble > 0)
				B.DoPlayerTumble(plr[n2], 30, mo[n2].angle, FixedHypot(mo[n2].momx, mo[n2].momy), false)
				if mo[n2].pushtics ~= nil then mo[n2].pushtics = $-1 end
			end
			B.ZLaunch(mo[n2], 5 * mo[n2].scale, false)

			return true
		end
	end
	
	B.TripExhaust = function(p)
		local mo = p.mo
		if not trip.IsValid(mo) return end
			
		if p.TRP.spikemode
			local maxtime = 4*TICRATE
			p.exhaustmeter = max(0,$-FRACUNIT/maxtime)
		end

		if not p.exhaustmeter
			if p.TRP.spikemode
				trip.RollReturn(p)
				mo.trip_ceilingstick = nil
				p.mo.flags2 = not ($ & MF2_OBJECTFLIP) and $|(MF2_OBJECTFLIP) or $ & ~(MF2_OBJECTFLIP)
				p.mo.eflags = not ($ & MFE_VERTICALFLIP) and $|(MFE_VERTICALFLIP) or $ & ~(MFE_VERTICALFLIP)
				mo.state = S_PLAY_TNROLL2
				p.pflags = ($|PF_THOKKED|PF_JUMPED) & ~PF_SPINNING
			elseif mo.state == S_PLAY_ROLL
				mo.state = S_PLAY_TNROLL2
				p.pflags = ($|PF_THOKKED|PF_JUMPED) & ~PF_SPINNING
			end
		end
		
		if (P_IsObjectOnGround(mo) and (not p.TRP.spikemode))
		or P_PlayerInPain(p)
			p.exhaustmeter = FRACUNIT
		end
	
		return true
	end

	
	-- Its Fine to Use B here, Its more optimized to use this over CBW_Battle		
	B.SkinVars["trip"] = {
		weight = 90,
		shields = 1,
		guard_frame = 1,
		func_priority = TripPrio,
		special = FireBreath,
		func_precollide = B.Trip_PreCollide,
		func_collide = B.Trip_Collide,
		func_postcollide = B.Trip_PostCollide,
		func_exhaust = B.TripExhaust,
	}

	loaded = true
end)


-- Fireball lock-on and resetting our fireballs' aerial boost when touching the ground
trip.BattleTargetFinder = function(p)
	local mo = p.mo
	if p.TRP.fireballBoost ~= nil and P_IsObjectOnGround(p.mo) then p.TRP.fireballBoost = 3 end

	// We had a target, but something happened to it.
	if mo.target and ((not mo.target.valid) or (not mo.target.health)) then mo.target = nil end

	// We have a target! Keep a close eye on them until they are outside of our targetting angle and distance or dead
	if mo.target and mo.target.valid
		P_SpawnLockOn(p, mo.target, S_LOCKON1)
		local anglediff = AngleFixed(mo.angle - R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y))/FRACUNIT
		if P_AproxDistance(mo.target.x - mo.x, mo.target.y - mo.y) > (trip.FIRRANGE + 200*FRACUNIT)
		or (anglediff > 45 and anglediff < 315)
			mo.target = nil 
		end
	end

	// We have no target and are in a neutral state. Search for something shootable every 5 tics.
	local twod = (twodlevel or mo.flags2 & MF2_TWOD)
    local ringdist, span
    if not(twod)
        ringdist = trip.FIRRANGE
        span = ANG30
    else
        ringdist = trip.FIRRANGE/2
        span = ANG20
    end
    local maxdist = FixedMul(ringdist, mo.scale)
    local closestdist = 0
    local closestmo = nil
	if p.actionstate == 0
	and not mo.target
		searchBlockmap("objects",function(pmo,enmo)
			if not (enmo.flags & MF_SHOOTABLE) return end
			if not (enmo.health) return end -- dead
			if not (enmo.player) and not (enmo.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR)) return end
			if enmo.type == MT_RING_REDBOX and not (p.ctfteam == 1) return end  //CTF monitor 
			if enmo.type == MT_RING_BLUEBOX and not (p.ctfteam == 2) return end
			if (enmo == pmo) return end
			if (enmo.flags2 & MF2_FRET) return end
			if (enmo.player and (CBW_Battle.MyTeam(p,enmo.player) or enmo.player.spectator)) return end //Disallow targeting teammates
			local zdist = (pmo.z + pmo.height/2) - (enmo.z + enmo.height/2) //Do angle/distance checks
			local dist = FixedHypot(pmo.x-enmo.x, pmo.y-enmo.y)
			local xyz_angle = abs(R_PointToAngle2(0, 0, dist, zdist))
			local xy_angle = abs(R_PointToAngle2(pmo.x + P_ReturnThrustX(pmo, pmo.angle, pmo.radius), pmo.y + P_ReturnThrustY(pmo, pmo.angle, pmo.radius), enmo.x, enmo.y) - pmo.angle)
			dist = FixedHypot(dist, zdist)
			if (dist > maxdist)
				return -- out of range
			end
			if (xyz_angle > span)
				return -- Don't home outside of desired angle!
			end
			if (twod
			and abs(pmo.y-enmo.y) > pmo.radius)
				return -- not in your 2d plane
			end
			if ((closestmo and closestmo.valid) and (dist > closestdist))
				return
			end
			if (xy_angle > span)
				return -- behind back
			end
			if not (P_CheckSight(pmo, mo))
				return -- out of sight
			end
			mo.target = enmo
			closestdist = dist
			
		end, mo,mo.x-maxdist,mo.x+maxdist,mo.y-maxdist,mo.y+maxdist)
	end
end


-- Battle-exclusive fire breath function for untransformed trip
-- very similar to super trip
trip.BattleFireBreath = function(p)
	local mo = p.mo

	for j=1, 2 do
		for i=-2,2 do
			local grav = (P_MobjFlip(mo) == 1) and mo.height - FixedMul(8*FRACUNIT, mo.scale) or mo.height
			local flame = P_SpawnMobj(mo.x + 52*cos(mo.angle), mo.y + 52*sin(mo.angle), mo.z + grav, MT_TRIPFLAME)
			flame.name = "combustion"
			flame.color = (gametyperules & GTR_TEAMS) and mo.color or trip.flameSkins[ P_RandomRange(1,#trip.flameSkins) ] // Team colors!
			flame.target = mo
			flame.angle = mo.angle + ANG1*22*i
			flame.scale = mo.scale * 3/2
			P_SetObjectMomZ(flame, -2*FRACUNIT)
			P_Thrust(flame, flame.angle, FixedMul(trip.BATTLEFLAMESPD, mo.scale) )
			P_Thrust(flame, mo.angle, FixedMul(p.speed/3, mo.scale) )
			flame.cusval = 1
			flame.extravalue1 = 0
		end
	end

	if p == consoleplayer then P_StartQuake(2*FRACUNIT, 10) end
	p.drawangle = mo.angle
end