-- Basically espio's ceiling cling! Mad props to Snu for this!

local function trip_skyCheck(p, flipcond)
	local mo = p.mo
	local rover = (flipcond) and mo.floorrover or mo.ceilingrover

	if (rover and rover.valid)
		local pic = (flipcond) and "toppic" or "bottompic"
		
		return rover[pic]:upper():find("F_SKY")
	else
		local sec = mo.subsector.sector
		local pic = (flipcond) and "floorpic" or "ceilingpic"
		
		return sec[pic]:upper():find("F_SKY")
	end
end

local function ResetSpikes(p)
	p.TRP.spikemode = false
	p.TRP.spikeframe = nil
	p.TRP.spiketics = nil
	p.TRP.spikeangle = nil
end

trip.RollReturn = function(p)

	local mo = p.mo
	if (mo.state == S_PLAY_TSPIKEROLL)
		local state = p.climbing and mo.state or S_PLAY_TNROLL1
			
		if (P_IsObjectOnGround(mo))
		and (p.speed < 5*mo.scale or not FixedHypot(mo.momx, mo.momy))
			p.pflags = $ & ~(PF_SPINNING)
			mo.momx = 0
			mo.momy = 0
			state = S_PLAY_STND
		end
		mo.state = state
	end
	ResetSpikes(p)
end

local function trip_FOFCheck(p)
	local mo = p.mo

	-- get the FOF, if we dont have one, then why are we even here?
	local rover = (mo.eflags & MFE_VERTICALFLIP) and mo.floorrover or mo.ceilingrover
	if not (rover and rover.valid) then return true end
	
	-- we don't need to check this
	if not (rover.flags & FF_EXISTS) then return true end
	if not (rover.flags & FF_BLOCKPLAYER or rover.flags & FF_QUICKSAND) then return true end
	
	-- it's a mario block that we need to hit
	if (rover.flags & FF_MARIO) then return false end
	if (rover.flags & FF_QUICKSAND) then return false end
	
	-- if we're here, it must be clean
	return true
end

local function trip_CeilingStick(p)
	local mo = p.mo
	
	if mo.skin ~= "trip" and not (trip.AbilityCheck(p))
		if (mo.trip_ceilingstick)
			mo.trip_ceilingstick = nil
			mo.flags2 = not ($ & MF2_OBJECTFLIP) and $|(MF2_OBJECTFLIP) or $ & ~(MF2_OBJECTFLIP)
			mo.eflags = not ($ & MFE_VERTICALFLIP) and $|(MFE_VERTICALFLIP) or $ & ~(MFE_VERTICALFLIP)
		end
		
		return 
	end
	
	if not trip.IsValid(mo) return end
	
	if not (mo.trip_ceilingstick)	-- we WANT to cling
		-- conditions we cant cling under
		if (p.gotflag or p.gotcrystal)	-- not while we have the flag (or the battlemod crystal)
		or (CBW_Battle and p.exhaustmeter == 0)	-- we're exhaused (battle mod)
		or (P_InQuicksand(mo)) -- not in quicksand
		or (mo.eflags & MFE_GOOWATER)	-- not under goop
		or p.TRP.wallreverse
		or p.climbing > 1
			return
		end
		
		-- attempt to cling
		if mo.state == S_PLAY_TRSPIKE	-- in "spikes" state
		or (p.climbing)	-- scaling a wall
			local checkz = mo.z + mo.height
			local checksurface = P_CeilingzAtPos(mo.x, mo.y, mo.z, mo.height)
			if (mo.eflags & MFE_VERTICALFLIP)
				checkz = mo.z
				checksurface = P_FloorzAtPos(mo.x, mo.y, mo.z, mo.height)
			end
			
			-- momz check
			local momzcheck = nil
			if ((mo.eflags & MFE_VERTICALFLIP) and mo.momz < 1)
			or (not (mo.eflags & MFE_VERTICALFLIP) and mo.momz > -1)
				momzcheck = true
			end
			
			-- check if we can cling!
			if (abs(checkz - checksurface) < FixedMul(mo.scale, trip.CEILSTICKRANGE))
			and (not trip_skyCheck(p, mo.eflags & MFE_VERTICALFLIP))
			and (trip_FOFCheck(p))
			and (momzcheck)
				-- let's flip!
				mo.flags2 = not ($ & MF2_OBJECTFLIP) and $|(MF2_OBJECTFLIP) or $ & ~(MF2_OBJECTFLIP)
				mo.eflags = not ($ & MFE_VERTICALFLIP) and $|(MFE_VERTICALFLIP) or $ & ~(MFE_VERTICALFLIP)
				mo.trip_ceilingstick = P_MobjFlip(mo)
				S_StartSound(mo, sfx_s23d)
				
				-- spikes state transition
				p.TRP.bounceCharge = 0
				p.TRP.bounced = false
				p.TRP.bounceLock = false
				
				-- wall stick stuff
				if (p.climbing)
					p.climbing = 0
					p.pflags = $ & ~(PF_JUMPED)
					
					-- get a bit of momentum
					mo.angle = $ + ANGLE_180
					p.drawangle = mo.angle
					
					local momentum = mo.momz
					local modifier = FRACUNIT*4/5
					P_InstaThrust(mo, mo.angle, FixedMul(modifier, momentum))
					--P_Thrust(mo, mo.angle - ANGLE_90, FixedMul(modifier, momentum["sideways"]))
					
					p.charability = CA_NONE
					trip.WallReset(p)
				else
					-- nvm cut momentum the regular way to give it a "stick" feel
					local modifier = trip.CEILSTICKMULT
					mo.momx = FixedMul(modifier, $)
					mo.momy = FixedMul(modifier, $)
				end
				
				-- safety nets
				P_SetOrigin(mo, mo.x, mo.y, checksurface - ((mo.eflags & MFE_VERTICALFLIP) and mo.height or 0))
				mo.momz = FixedMul(mo.scale, -1*P_MobjFlip(mo))
				p.lastbuttons = $|(BT_JUMP)	-- little hack to prevent instant jumps
				p.TRP.spikemode = true
				p.pflags = $|PF_SPINNING
			end
		end
	else	
		-- we HAVE clinged
		-- fall off conditions
		if not (P_IsObjectOnGround(mo))	-- we're no longer on the ceiling!
		or (mo.trip_ceilingstick != P_MobjFlip(mo))	-- we flipped while we were flipped, flip us back to what we should be flipped to!
		or (mo.tracer and (mo.tracer.type == MT_TUBEWAYPOINT))	-- we're in a zoomtube, put us back
		//or (not (p.cmd.buttons & BT_JUMP) and not stasischeck)	-- we're not holding jump anymore (unless in full stasis)
		or (p.gotflag or p.gotcrystal)	-- we have the ctf flag (or the battlemod crystal), no cheesing!
		or (trip_skyCheck(p, mo.trip_ceilingstick == 1))	-- we somehow got our way to the sky
		or (CBW_Battle and p.exhaustmeter == 0)	-- we're exhaused (battle mod)
		or not p.TRP.spikemode	-- not in spikes mode

			trip.RollReturn(p)
			mo.trip_ceilingstick = nil
			mo.flags2 = not ($ & MF2_OBJECTFLIP) and $|(MF2_OBJECTFLIP) or $ & ~(MF2_OBJECTFLIP)
			mo.eflags = not ($ & MFE_VERTICALFLIP) and $|(MFE_VERTICALFLIP) or $ & ~(MFE_VERTICALFLIP)
			S_StartSound(mo, sfx_s23d)
			
			-- dont set state while being controlled
			local stateValid = (mo.state >= S_PLAY_STND and mo.state <= S_PLAY_DASH) or (not p.TRP.spikemode)
			
			if (not P_IsObjectOnGround(mo) and stateValid)
			and (not p.climbing)
			and not (mo.tracer)
			//and not (p.pflags & PF_SPINNING)
				p.pflags = $|(PF_JUMPED|PF_SPINNING)
				//mo.trip_charge_state = trip.JumpChargeStates["MULTIABILITY"]
				--mo.state = S_PLAY_TRSPIKE and S_PLAY_TRSPIKE or S_PLAY_ROLL
				mo.momz = -1 * P_MobjFlip(mo)
			end
			
			return
		end
		
		-- jump off conditions!
		if (p.cmd.buttons & BT_JUMP)
		and not (p.lastbuttons & BT_JUMP)
			P_DoJump(p, true)
			p.pflags = ($|PF_SPINNING) & ~(PF_STARTJUMP)
			S_StartSound(mo, sfx_jump)
			
			-- these and play sound
			S_StartSound(mo, sfx_s23d)
			
			-- NOW remove the ceiling cling
			trip.RollReturn(p)
			mo.trip_ceilingstick = nil
			mo.flags2 = not ($ & MF2_OBJECTFLIP) and $|(MF2_OBJECTFLIP) or $ & ~(MF2_OBJECTFLIP)
			mo.eflags = not ($ & MFE_VERTICALFLIP) and $|(MFE_VERTICALFLIP) or $ & ~(MFE_VERTICALFLIP)
			return
		end
	end
end

local function SpikesThinker(p)
	local mo = p.mo
	if not trip.IsValid(mo) return end
	
	if not (p.TRP.spikemode) then return end
	local cmd = p.cmd
	
	if (P_PlayerInPain(p))	-- we got hurt
	or (mo.eflags & MFE_SPRUNG)	-- hit a spring
	or (p.powers[pw_carry])	-- we got carried
	or (p.panim == PA_PAIN)	-- pain pain pain pain pain
	or (p.powers[pw_nocontrol])	-- no control
	or (p.actionstate)	-- battle support
	or (p.airdodge)	-- battle support (2)
		trip.RollReturn(p)
		return
	end
	
	-- re-apply PF_SPINNING accordingly
	if not (p.pflags & PF_SPINNING)
		local canstand = true
		canstand = (not mo.standingslope or (mo.standingslope.flags & SL_NOPHYSICS) or abs(mo.standingslope.zdelta) < FRACUNIT/2)
		
		if not (P_IsObjectOnGround(mo))
		or (p.speed >= 5*mo.scale)
		or not (canstand)
			p.pflags = $|PF_SPINNING
		end
	end
	
	-- movement
	if not (P_IsObjectOnGround(mo))
		-- properly remove startjump if we're not holding jump
		if (p.pflags & PF_STARTJUMP)
		and not (cmd.buttons & BT_JUMP)
			-- PF_STARTJUMP doesnt get removed if we're falling and let go of jump
			p.pflags = $ & ~(PF_STARTJUMP)
		end
		
		-- increased gravity to land on the ground
		//if not ((p.pflags & PF_STARTJUMP) and (mo.momz * P_MobjFlip(mo)) > 0)	-- less lenient
		if not (p.pflags & PF_STARTJUMP)	-- more lenient
			local modifier = trip.SpikesGravity
			mo.momz = $ + (FixedMul(P_GetMobjGravity(mo), modifier))
		end
	else
		-- spin control and acceleration
		if (cmd.forwardmove and not ((twodlevel) or (mo.flags2 & MF2_TWOD)))
		or cmd.sidemove
			-- blaze spin control
			local oldspeed = FixedHypot(mo.momx, mo.momy)
			local factor = max(max(81 - oldspeed*3/mo.scale, 12) - max(oldspeed*2/3/mo.scale - 36, 0), 6)
			
			local angle = p.cmd.angleturn<<16
			if mo.flags2 & MF2_TWOD or twodlevel
				angle = ANGLE_90
			end
						
			P_Thrust(mo, angle, cmd.forwardmove*mo.scale/factor)
			P_Thrust(mo, angle+ANGLE_90, -cmd.sidemove*mo.scale/factor)
			
			local speed = FixedHypot(mo.momx, mo.momy)
			if (speed > oldspeed)
				speed = oldspeed
				P_InstaThrust(mo, R_PointToAngle2(0, 0, mo.momx, mo.momy), oldspeed)
			end
			
			-- accelerate
			local momentumangle = R_PointToAngle2(0, 0, mo.momx, mo.momy) - trip.GetControlAngle(p)
			local anglefactor = abs(cos((trip.AngToInt(momentumangle)/2) * ANG1))
			local anglespeed = FixedMul(anglefactor, speed)	-- this isnt local so we can save the maxspeed afterwards!
				
			local maxspeed = FixedMul(mo.scale, FixedMul(trip.SpikesNormalspeedMultiplier, p.normalspeed))
			if (mo.eflags & MFE_UNDERWATER) then maxspeed = FixedDiv($, FRACUNIT*2) end
			local modifier = (FixedHypot(p.cmd.forwardmove, p.cmd.sidemove) * FRACUNIT) / 50
			maxspeed = FixedMul(modifier, $)
			
			if (anglespeed < maxspeed)
				local scalar = max(0, FixedDiv(anglespeed, maxspeed))
				local accel_max = maxspeed - anglespeed
				local min_thrust = FixedMul(trip.SpikesAccelMinThrustModifier, trip.SpikesAccelMaxThrust)
				local accel = min(accel_max, ease.outsine(scalar, trip.SpikesAccelMaxThrust, min_thrust))
				if (mo.eflags & MFE_UNDERWATER) then accel = FixedDiv($, FRACUNIT*5/2) end
				
				P_Thrust(mo, trip.GetControlAngle(p), FixedMul(mo.scale, accel))
			end
		else	-- apply auto-brake
			if (mo.momx or mo.momy)
				local momentumangle = R_PointToAngle2(0, 0, mo.momx, mo.momy)
				P_Thrust(mo, momentumangle, trip.SpikesAutobrakeThrust)
				momentumangle = $ - R_PointToAngle2(0, 0, mo.momx, mo.momy)
				local anglefactor = cos(momentumangle)
				local anglespeed = FixedMul(anglefactor, FixedHypot(mo.momx, mo.momy))
				if (anglespeed < 0)
					-- kill momentum
					mo.momx, mo.momy = 0, 0
				end
			end
		end
	end
	
	-- state control
	local state = S_PLAY_TSPIKEROLL
	if (mo.state != state) then mo.state = state end
	if (p.TRP.spikeframe == nil) then p.TRP.spikeframe = 0 end
	
	local speed = FixedHypot(mo.momx, mo.momy)
	if (speed)	-- gotta have SOME speed for this
		-- increase frame
		local max_speed = FixedMul(mo.scale, FixedMul(trip.SpikesMaxFrameTicsSpeedMultiplier, p.normalspeed))
		local scalar = min(FRACUNIT, FixedDiv(FixedHypot(mo.momx, mo.momy), max(max_speed,1)))
		local min_tics = ease.linear(scalar, trip.SpikesMaxFrameTics, trip.SpikesMinFrameTics)
		min_tics = max(trip.SpikesMinFrameTics, min(trip.SpikesMaxFrameTics, $))	-- gotta make sure it stays in range...
		
		if (p.TRP.spiketics == nil)
			p.TRP.spiketics = min_tics
		end
		p.TRP.spiketics = $ and $-1
		
		if not (p.TRP.spiketics)
			p.TRP.spiketics = min_tics
			
			p.TRP.spikeframe = $+1
			local max_frames = skins[mo.skin].sprites[states[S_PLAY_TSPIKEROLL].frame].numframes - 1
			if p.TRP.spikeframe > max_frames
				p.TRP.spikeframe = 0
			end
		end
		
		if speed >= max_speed/2
			if not (leveltime%3)
				local rocc = trip.DoWallStones(mo, nil, true)
				rocc.flags2 = $ & ~MF2_OBJECTFLIP
			end
			if not (leveltime%2) 
				local boo = P_SpawnGhostMobj(p.mo)
				boo.tics = 4
				boo.scale = p.mo.scale -- y tho
			end
		end
		
		-- set angle
		p.TRP.spikeangle = R_PointToAngle2(0, 0, mo.momx, mo.momy)
	else
		p.TRP.spiketics = nil
	end
	
	local frameflags = (mo.frame & ~FF_FRAMEMASK)
	mo.frame = frameflags | p.TRP.spikeframe
	if (p.TRP.spikeangle != nil)
		p.drawangle = p.TRP.spikeangle
	end
	
	-- and finally, attempt to climb any walls we come in contact with
	local too = (twodlevel) or (mo.flags2 & MF2_TWOD)
	if (cmd.forwardmove > 0 or too)
		trip.DoWallClimb(p)
		if p.climbing
			-- We managed to climb a wall and were holding FORWARD when we did. Invert our up-down controls.
			p.TRP.wallreverse = true
		end
	end
	
end

local function trip_CeilingStickJumpSpecial(p)
	local mo = p.mo
	if not trip.IsValid(mo) return end
	
	return mo.trip_ceilingstick
end

addHook("ThinkFrame", do
	for p in players.iterate
		local mo = p.mo
		if not (mo and mo.valid) then continue end
		trip_CeilingStick(p)
		SpikesThinker(p)
	end
end)

addHook("JumpSpecial", function(p)
	local mo = p.mo
	if not ((mo and mo.valid) and mo.health) then return end
	
	local ceilingstick = trip_CeilingStickJumpSpecial(p)
	if (ceilingstick) then return true end
end)