
local FRACDIV = FRACUNIT/100

-- Aww
local function AmyHugs(mo)
	if not mo.valid return end
	if not mo.target or not mo.target.valid or mo.target.skin ~= "trip" return end
	local pmo = mo.target
	if not pmo.player or (pmo.player and not pmo.player.valid) or not P_IsObjectOnGround(pmo) return end
	local p = pmo.player

	if mo.state == S_ROSY_HUG
		pmo.sprite2 = p.powers[pw_super] and SPR2_TAL1 or SPR2_TAL0
		pmo.frame = ($ & ~FF_FRAMEMASK)|A
		if pmo.state ~= S_PLAY_STND then pmo.state = S_PLAY_STND end
		pmo.tics = 900000
		pmo.tracer = mo
		if not (leveltime%55)
			local heart = P_SpawnMobjFromMobj(pmo, 5*cos(pmo.angle), 5*sin(pmo.angle), pmo.height, MT_UNKNOWN)
			heart.sprite = SPR_LHRT
			heart.scale = 1
			heart.destscale = FRACUNIT/2
			heart.scalespeed = FRACUNIT/40
			heart.extravalue1 = heart.x
			heart.extravalue2 = heart.y
			heart.carpet = 1
			heart.fuse = 4*TICRATE
		end
	end
end

-- Make a handful of hearts flow up ever so often
local function AmyHearts(mo)
	if not mo.valid return end
	if mo.carpet
		mo.cusval = (sin( (((mo.carpet+1)%360)+1) * ANG1 * 5) * 10)/FRACUNIT
		mo.carpet = $+1
		mo.angle = R_PointToAngle(mo.extravalue1, mo.extravalue2) + ANGLE_90
		P_MoveOrigin(mo,
					 mo.extravalue1 + mo.cusval*cos(mo.angle),
					 mo.extravalue2 + mo.cusval*sin(mo.angle),
					 mo.z+FRACUNIT
		)
		if mo.fuse < 24 then mo.destscale = 1 end
	end
end

-- Namesake joke
local TriggerTrip = function(p)
	local mo = p.mo
	p.TRP.youFoolYouAbsoluteBuffoon = nil
	mo.z = $ + FRACUNIT*2
	P_SetObjectMomZ(mo, 7*FRACUNIT)
	p.pflags = $ | PF_JUMPED | PF_THOKKED
	P_InstaThrust(mo, p.drawangle, 4*FRACUNIT)
	p.TRP.uhOh = true
	p.powers[pw_nocontrol] = TICRATE*2
	S_StartSound(mo, sfx_toops)
	mo.state = S_PLAY_PAIN
	mo.sprite2 = SPR2_LAND
end

-- Don't skid too much in a short amount of time!
local function Tripping(p)
	local mo = p.mo
	
	if CBW_Battle and (p.landlag) or (mo.eflags & MFE_JUSTHITFLOOR) return end
	
	if p.TRP.skidCount == nil then p.TRP.skidCount = 0 end

	if mo.state == S_PLAY_SKID and p.TRP.lastState ~= S_PLAY_SKID and not p.TRP.youFoolYouAbsoluteBuffoon
		p.TRP.skidCount = $+1
		p.TRP.skidReset = TICRATE*2
		if p.TRP.skidCount == 3 
			mo.sprite2 = SPR2_EDGE
			mo.frame = A|FF_ANIMATE
		end
	end

	if mo.state == S_PLAY_SKID and mo.sprite2 == SPR2_EDGE and mo.anim_duration == 0
		mo.anim_duration = 2
	end

	if p.TRP.skidCount > 3
		p.TRP.youFoolYouAbsoluteBuffoon = 6
		p.TRP.skidCount = 0
		p.TRP.skidReset = 0
		mo.sprite2 = SPR2_EDGE
		mo.frame = A
	end

	if p.TRP.youFoolYouAbsoluteBuffoon
		p.TRP.youFoolYouAbsoluteBuffoon = $-1
		if not p.TRP.youFoolYouAbsoluteBuffoon
			TriggerTrip(p)
		end
	end

	if p.TRP.youFoolYouAbsoluteBuffoon and mo.state ~= S_PLAY_SKID then p.TRP.youFoolYouAbsoluteBuffoon = nil end

	if p.TRP.uhOh and mo.state ~= S_PLAY_PAIN
	and p.TRP.lastState ~= S_PLAY_SKID and p.TRP.lastState ~= S_PLAY_PAIN
		p.powers[pw_nocontrol] = 0
		p.TRP.uhOh = nil
		p.TRP.youFoolYouAbsoluteBuffoon = nil
	end

	if mo.state == S_PLAY_TRIPTRIP 
		p.powers[pw_nocontrol] = 32768 + 2
		if mo.spritexscale > FRACUNIT 
			mo.spritexscale = $ - FRACDIV*5
			if mo.spritexscale < FRACUNIT then mo.spritexscale = FRACUNIT end
		end
		if mo.spriteyscale < FRACUNIT 
			mo.spriteyscale = $ + FRACDIV*5
			if mo.spriteyscale > FRACUNIT then mo.spriteyscale = FRACUNIT end
		end
	end
	
	if p.TRP.lastState == S_PLAY_TRIPTRIP and mo.state ~= S_PLAY_TRIPTRIP
		mo.spritexscale = FRACUNIT
		mo.spriteyscale = FRACUNIT
	end

	if p.TRP.skidReset 
		p.TRP.skidReset = $-1
		if not p.TRP.skidReset then p.TRP.skidCount = 0 end
	end
end

-- The true Smash Bros Brawl experience
local function ExcessiveTripping(p)
	local mo = p.mo

	if not p.TRIPTRIPPINGBULLSHIT return end

	if p.TRIPBRAWL_F == nil
		p.TRIPBRAWL_F = p.cmd.forwardmove
		p.TRIPBRAWL_S = p.cmd.sidemove
	end

	if P_IsObjectOnGround(mo) 
		-- Passive movement checks
		if p.speed > 10*FRACUNIT

			-- Are we moving? Do a 3% check every half second.
			if (p.panim == PA_WALK or p.panim == PA_RUN)
			and not (leveltime%(TICRATE/2))
				if P_RandomRange(1, 100) < 4 then TriggerTrip(p) end
			-- Are we skidding? Do a 3% check EVERY TIC
			elseif p.mo.state == S_PLAY_SKID and P_IsObjectOnGround(mo)
				if P_RandomRange(1, 100) < 4 then TriggerTrip(p) end
			end

		end

		-- Keypress checks. Every time you press a key that was previously idle, that's a 2% chance
		if (p.panim == PA_WALK or p.panim == PA_RUN or p.panim == PA_IDLE)
			if (p.cmd.forwardmove > 0 and p.TRIPBRAWL_F <= 0)
			or (p.cmd.forwardmove < 0 and p.TRIPBRAWL_F >= 0)
			or (p.cmd.sidemove > 0 and p.TRIPBRAWL_S <= 0)
			or (p.cmd.sidemove < 0 and p.TRIPBRAWL_S >= 0)
				if P_RandomRange(1, 100) < 3 then TriggerTrip(p) end
			end
		end
	end

	p.TRIPBRAWL_F = p.cmd.forwardmove
	p.TRIPBRAWL_S = p.cmd.sidemove

end

-- Finishing up Tripping in a post think frame to avoid sprite change shenanigans
local function TrippingPT(p)
	local mo = p.mo

	if p.TRP.lastState == S_PLAY_PAIN 
	and p.TRP.uhOh 
	and P_IsObjectOnGround(mo)
	and p.playerstate == PST_LIVE
		p.TRP.uhOh = nil
		mo.state = S_PLAY_TRIPTRIP
		p.TRP.squashpanic = 20
		S_StartSound(mo, sfx_kc43)
		S_StartSound(mo, sfx_tfpla)
		P_InstaThrust(mo, mo.angle, 0)
		mo.spritexscale = FRACUNIT + FRACDIV*40
		mo.spriteyscale = FRACUNIT - FRACDIV*40
		local addAngle = 0
		local dustNum = 10
		for i=1, dustNum
			local poof = P_SpawnMobjFromMobj(mo, 5*cos(mo.x), 5*sin(mo.x), 0, MT_SPINDUST)
			poof.angle = p.drawangle + addAngle
			addAngle = $ + FixedAngle( (360/dustNum) * FRACUNIT)
			P_InstaThrust(poof, poof.angle, 20*FRACUNIT)
			P_SetObjectMomZ(poof, 3*FRACUNIT)
			poof.scale = FRACUNIT - FRACUNIT/4
			poof.flags = $ & ~MF_NOGRAVITY
		end
	end
end

-- Trip and fang are duking it out!
local function TripAndFangsArgument(mnum)
	local map = mapheaderinfo[mnum]
	if not map return end
	if map.lvlttl:lower() == "arid canyon" and map.actnum == 3 and (maptol & TOL_COOP)
		for p in players.iterate
			if not p.valid continue end
			if not p.mo or not p.mo.valid continue end
			if p.mo.skin == "trip" and p.TFANGMUS
				S_ChangeMusic("TRFAN", true, p, nil, nil, 5400)
			end
		end
	end
end

-- The duel between trip and fang ended. Let's fade back to the usual ACZ1 music.
local function FangMusicStop(mo)
	if (not mo) or (not mo.valid) return end
	if S_MusicPlaying() and S_MusicName() == "TRFAN"
		S_ChangeMusic("ACZ1", true, nil, nil, nil, 2000)
	end
end

-- Stop fang's boss music from restarting when a player dies in co-op mode in ACZ3
local function FangChangePrevention(oldname, newname, flags, looping)
	local map = mapheaderinfo[gamemap]
	if oldname == "TRFAN" and newname == "VSFANG"
	and map.lvlttl:lower() == "arid canyon" and map.actnum == 3 and (maptol & TOL_COOP)
		return "TRFAN"
	end
end

-- Easter egg stuff to be executed during PlayerThink
trip.EasterEggsT = function(p)
	Tripping(p)
	ExcessiveTripping(p)
end
-- ...and during PostThink. P is being supplied to both in Trip_Main
trip.EasterEggsPT = function(p)
	TrippingPT(p)
end

-- Why
COM_AddCommand("smashbrawl", function(p, arg)
	if not p or p and not p.valid return end

	if arg
		arg = $:lower()

		-- Restrict this command's usage in battle mode
		local battle = CBW_Battle and CBW_Battle.BattleGametype()

		if battle and (not trip.ALLOWSMASHBRAWL) and (p ~= server and not IsPlayerAdmin(p)) and arg ~= "mute"
			CONS_Printf(p, "\x04 An admin must allow this command before it is enabled in battle mode")
			return
		end

		if (arg == "1" or arg == "on" or arg == "yes" or arg == "true")
			CONS_Printf(p, "\x04 Enjoy the chaos")
			p.TRIPTRIPPINGBULLSHIT = true

		elseif (arg == "0" or arg == "off" or arg == "no" or arg == "false" or arg == "mute")
			if arg ~= "mute" then CONS_Printf(p, "\x04 Understandable") end
			p.TRIPTRIPPINGBULLSHIT = false

		elseif (arg == "all")
			if not battle
				CONS_Printf(p, "\x04 You are not in battle mode")
				return
			elseif p ~= server and not IsPlayerAdmin(p)
				CONS_Printf(p, "\x04 Only admins can use this command")
				return
			else
				CONS_Printf(p, "\x04 All players can now access the command freely")
				trip.ALLOWSMASHBRAWL = true
			end

		elseif (arg == "none")
			if not battle
				CONS_Printf(p, "\x04 You are not in battle mode")
				return
			elseif p ~= server and not IsPlayerAdmin(p)
				CONS_Printf(p, "\x04 Only admins can use this command")
				return
			else
				CONS_Printf(p, "\x04 All players have been locked out of using smashbrawl")
				trip.ALLOWSMASHBRAWL = false
				for p in players.iterate do p.TRIPTRIPPINGBULLSHIT = false end
			end
		end

	else
		CONS_Printf(p, "\x04 For the true 2008 experience.")
		CONS_Printf(p, "\x82 Possible arguments: ")
		CONS_Printf(p, "\x88 1 / true / yes / on  - Start the chaos")
		CONS_Printf(p, "\x88 0 / false / no / off - End the chaos")
		CONS_Printf(p, "")
		CONS_Printf(p, "\x82 [ADMIN ONLY]")
		CONS_Printf(p, "\x88 all - Enable smashbrawl for all players in battle mode")
		CONS_Printf(p, "\x88 none - Disable smashbrawl for all players in battle mode [default]")
	end
end)

addHook("MusicChange", FangChangePrevention)
addHook("MobjThinker", AmyHugs, MT_ROSY)
addHook("MobjThinker", AmyHearts, MT_UNKNOWN)
addHook("MapLoad", TripAndFangsArgument)
addHook("BossDeath", FangMusicStop, MT_FANG)