
-- Fire breath function. Flame thinker can be found on Trip_Mobjs
local function FireBreath(p)
	local mo = p.mo

	if mo.GSgrind and mo.GSgrind.grinding return end
	if p.powers[pw_carry] return end

	-- Am I being dumb?
	for k,v in ipairs(trip.NOFLAMETABLE)
		if v == spr2names[mo.sprite2] return end
	end

	-- Concentrate our flames the more we use them
	if p.TRP.flameGas < FRACUNIT
		p.TRP.flameGas = $ + FRACUNIT/trip.FLAMEGAS
		if p.TRP.flameGas > FRACUNIT then p.TRP.flameGas = FRACUNIT end
	end

	-- We'll create two flames which will sine wave left and right. Which is which is determined by flame.LR
	if (leveltime%2)
		for i=1,2 do
			local rand = P_RandomRange(-2,2) * (FRACUNIT/3) -- why
			local grav = (P_MobjFlip(mo) == 1) and mo.height - FixedMul(12*FRACUNIT, mo.scale) or mo.height+4*FRACUNIT+rand
			local reach = FixedMul(52, mo.scale)
			local flame = P_SpawnMobj(mo.x + reach*cos(mo.angle), mo.y + reach*sin(mo.angle), mo.z + grav, MT_TRIPFLAME)
			flame.name = "fire breath"
			flame.color = trip.flameSkins[ P_RandomRange(1,#trip.flameSkins) ]
			flame.target = mo
			flame.angle = mo.angle
			flame.scale = FixedMul(FRACUNIT + FRACUNIT/2 + rand, mo.scale)
			flame.spritexscale = FRACUNIT*11/10
			flame.spriteyscale = flame.spritexscale
			P_SetObjectMomZ(flame, -6*FRACUNIT)
			P_Thrust(flame, mo.angle, FixedMul(p.speed - p.speed/6 + trip.FLAMESPD, mo.scale) )
			if i == 1 then flame.LR = true end
		end
	end

	-- Brrrrrrrrr
	if not p.TRP.flameTime then S_StartSound(p.mo, sfx_trftst) end
	p.TRP.flameTime = $+1

	if p.TRP.flameTime == (TICRATE*4) - 5
		p.TRP.flameTime = 450
	end
	if p.TRP.flameTime >= 450 and not (p.TRP.flameTime%150) then S_StartSound(p.mo, sfx_trftlo) end
	
	if not (leveltime%10)
		if p == consoleplayer then P_StartQuake(2*FRACUNIT, 10) end
	end

	if P_IsObjectOnGround(mo) then
		mo.state = p.speed and S_PLAY_FLY or S_PLAY_CLIMB
	else
		mo.state = S_PLAY_FLY
	end

	p.drawangle = mo.angle
end

local function BreathStateReturn(p)
	p.TRP.flameTime = 0
	S_StopSoundByID(p.mo, sfx_trftst)
	S_StopSoundByID(p.mo, sfx_trftlo)
	if p.speed > FRACUNIT
		if P_IsObjectOnGround(p.mo) then return p.speed >= p.runspeed and S_PLAY_RUN or S_PLAY_FLOAT_RUN
		else return p.speed >= p.runspeed and S_PLAY_WALK or S_PLAY_FLOAT end
	else
		return P_IsObjectOnGround(p.mo) and S_PLAY_STND or S_PLAY_FLOAT
	end
end

-- Different controls for each of the three control schemes
-- yes, this is repeated code. yes, I should optimize this. no, I won't.
local function SuperControls(p, mo)
	
	
	-- Adapting our ascent and descent if we are in water
	local grav = min(P_GetMobjGravity(mo)*-2*P_MobjFlip(mo), FRACUNIT*3/2)
	local flight = FixedMul(trip.FLYSPD, grav)
	if (mo.eflags & MFE_UNDERWATER) then flight = $/2 end

	-- SCHEME 1 --> JUMP rises, RELEASING JUMP falls, SPIN flames
	if p.cmd.buttons & BT_JUMP
		P_SetObjectMomZ(mo, flight, true)
	elseif not P_IsObjectOnGround(p.mo) and not p.TRP.springTime
		P_SetObjectMomZ(mo, -flight + flight/4, true)
	end
	if p.cmd.buttons & BT_SPIN
		FireBreath(p)
	end

	mo.momz = (mo.eflags & MFE_SPRUNG) and $ or trip.Clamp($, -trip.MAXFLYSP, trip.MAXFLYSP)
end

-- Mostly animation stuff
trip.SuperPreThinker = function(p)
	local mo = p.mo
	local GS = mo.GSgrind

	-- no
	mo.milnejoin = false
	p.milne3tapping = false

	if GS
		if GS.grinding
			mo.sprite2 = SPR2_GRND|FF_SPR2SUPER
			return
		elseif GS.JumpRamp
			mo.sprite2 = SPR2_PAIN|FF_SPR2SUPER
		end
	end

	if mo.state >= S_PLAY_SUPER_TRANS1 and mo.state <= S_PLAY_SUPER_TRANS6 return end

	if ((p.panim == PA_ROLL) or mo.state == S_PLAY_ROLL or (p.powers[pw_carry] == CR_ZOOMTUBE) or (p.powers[pw_carry] == CR_MACESPIN) or (p.pflags & PF_SPINNING))
	and not trip.SuperAreaCheck(mo)
		trip.MaintainLightOrb(p)
		return
	end

	-- [anger]
	if mo.state == S_PLAY_WALK or mo.state == S_PLAY_RUN or mo.state == S_PLAY_FLY
	or mo.state == S_PLAY_FLOAT or mo.state == S_PLAY_FLOAT_RUN or mo.state == S_PLAY_SWIM
	or (mo.state == S_PLAY_FALL and (p.cmd.buttons & BT_JUMP) and not p.TRP.jumpHold)
	
		if mo.state == S_PLAY_FALL then mo.state = S_PLAY_WALK end
		mo.tics = 1
		if (mo.frame & FF_FRAMEMASK) ~= p.TRP.lastFrame and (mo.frame & FF_FRAMEMASK) == D
			if (mo.eflags & MFE_UNDERWATER)
				S_StartSoundAtVolume(mo, P_RandomRange(sfx_bubbl1,sfx_bubbl5),180)
				for i=1, 8 do
					local ang = p.drawangle + ((i%2) and -ANGLE_90 or ANGLE_90)
					local R1 = P_RandomRange(18,21)
					local R2 = P_RandomRange(18,21)
					local bub = P_SpawnMobjFromMobj(mo, R1*cos(ang),R2*sin(ang),40*FRACUNIT, MT_SMALLBUBBLE)
					bub.fuse = TICRATE
				end
			else
				S_StartSound(mo, sfx_tflap)
			end
		end
		if not P_IsObjectOnGround(mo)
			if mo.momz*P_MobjFlip(mo) > 0 or (p.cmd.buttons & BT_JUMP)
				if (mo.frame & FF_FRAMEMASK) ~= p.TRP.lastFrame then mo.tics = 5 end
			elseif mo.momz*P_MobjFlip(mo) <= 0 and not (p.cmd.buttons & BT_JUMP)
				mo.frame = A
				mo.tics = 2
			end
		else
			if (mo.frame & FF_FRAMEMASK) ~= p.TRP.lastFrame then mo.tics = 7 end
		end
		if mo.momz*P_MobjFlip(mo) < -20*FRACUNIT and not (p.cmd.buttons & BT_JUMP) then mo.state = S_PLAY_FALL end
	end

	if mo.state == S_PLAY_SPRING then mo.state = S_PLAY_JUMP end
	if mo.state == S_PLAY_JUMP and (mo.frame & FF_FRAMEMASK) == E
		if p.TRP.lastFrame ~= E then S_StartSound(mo, sfx_tflap) end
		mo.tics = 9000
		if mo.momz*P_MobjFlip(mo) < 0 then mo.state = S_PLAY_FALL end
	end

	if not (mo.frame & FF_FULLBRIGHT) then mo.frame = $|FF_FULLBRIGHT end

	p.TRP.lastFrame = (mo.frame & FF_FRAMEMASK)

end


-- Called from Trip_Main's PlayerThink in case we are super
trip.SuperThinker = function(p)
	local mo = p.mo
	
	-- Changes made when first transforming
	if not p.TRP.superReturn
		-- Making an additional check here since the sol emeralds bypass this very important condition when going super 
		if not trip.SuperAreaCheck(mo)
			p.powers[pw_super] = 0
			P_RestoreMusic(p)
			CONS_Printf(p, "\x03Trip needs more space to access her dragon form")
			return
		end
		p.TRP.truesize = mo.scale
		p.TRP.supersize = mo.scale + mo.scale/3
		p.TRP.lastState = S_PLAY_STND
		p.TRP.wallTime = 0
		p.TRP.superreturntimer = TICRATE*3
		p.charflags = $ | SF_NOJUMPSPIN
	end

	p.charability2 = CA2_NONE
	p.charflags = $ & ~SF_NOSUPERSPRITES

	if ((p.panim == PA_ROLL) or mo.state == S_PLAY_ROLL or (p.pflags & PF_SPINNING))
	and trip.SuperAreaCheck(mo) and not (p.powers[pw_carry] == CR_ZOOMTUBE) and not (p.powers[pw_carry] == CR_MACESPIN)
		mo.state = S_PLAY_FLY
		p.pflags = $ & ~PF_SPINNING
	end

	mo.radius = mo.state == S_PLAY_LIGHTBALL and skins["trip"].radius or FixedMul(trip.SUPERRAD, mo.scale)
	
	local underwaterheight = -(mo.watertop - mo.z - 10*FRACUNIT)/638977 -- very specific number
	if underwaterheight > -6 and underwaterheight < 0
		p.powers[pw_underwater] = 0
		if (not p.TSUPERMUS) or (p.TSUPERMUS and S_MusicName(p) ~= "TRSUP") then P_RestoreMusic(p) end
	end
	
	-- Super flight conditions and flags
	if p.TRP.superFlight

		-- Make sure we can keep popping monitors
		p.pflags = $ | PF_JUMPED | PF_JUMPSTASIS
		mo.momz = $ - P_GetMobjGravity(mo)
		p.scoreadd = 0

		-- Rise, fall and fire breath controls while flying
		if (not p.powers[pw_nocontrol])
			SuperControls(p, mo)
		end

		-- We touched the ground. Get our regular controls back
		if P_IsObjectOnGround(mo) or (mo.eflags & MFE_SPRUNG)
		or (CBW_Battle and p.airdodge and p.airdodge > 0)
		or p.powers[pw_carry]
			p.TRP.superFlight = false
			p.pflags = $ & ~PF_JUMPSTASIS & ~PF_JUMPED
			-- Only do the next few actions if we entered this condition from landing
			if P_IsObjectOnGround(mo)
				S_StartSoundAtVolume(p.mo, sfx_s23b, 180)
				if not (mo.eflags & MFE_UNDERWATER)
					-- I should really make a function for this. oh well.
					local addAngle = 0
					for i=1,8 do
						local dust = P_SpawnMobjFromMobj(mo, 0, 0, 6*FRACUNIT, MT_SPINDUST)
						dust.frame = $ + FF_TRANS50
						dust.angle = p.mo.angle + addAngle
						addAngle = $ + FixedAngle( 45 * FRACUNIT )
						P_InstaThrust(dust, dust.angle, 12*FRACUNIT )
						dust.scale = FRACUNIT/2
					end
				end
				-- Trip is a heavy girl as a dragon. bust up whatever we landed on.
				for rover in p.mo.subsector.sector.ffloors()
					if not (rover.flags & FF_EXISTS) or not (rover.flags & FF_BUSTUP) then continue end
					if mo.z >= rover.topheight + mo.height 
					or mo.z + mo.momz + mo.height < rover.bottomheight
						continue
					end
					EV_CrumbleChain(sector, rover)
				end
			end
		end
		
		-- Are we inside goop? 
		if (mo.eflags & MFE_UNDERWATER)
			for rover in mo.subsector.sector.ffloors()
				if not (rover.flags & FF_GOOWATER) then continue end
				p.TRP.superFlight = false
				p.pflags = $ & ~PF_JUMPSTASIS & ~PF_JUMPED
			end
		end
	end

	if (p.TRP.lastState == S_PLAY_FLY or p.TRP.lastState == S_PLAY_CLIMB or p.TRP.lastState == S_PLAY_SWIM)
	and not (p.cmd.buttons & BT_SPIN)
		mo.state = BreathStateReturn(p)
	end
	
	if not (p.cmd.buttons & BT_SPIN)
		p.TRP.flameTime = 0
	end

	if p.TRP.superFlight and not P_IsObjectOnGround(p.mo)
		p.pflags = $|PF_CANCARRY
	else
		p.pflags = $ & ~PF_CANCARRY
	end
	
	-- Sparkles!
	if not (leveltime%2)
		local rad = (mo.radius + mo.radius/2)/FRACUNIT
		local pos = {P_RandomRange(-rad, rad)*FRACUNIT, P_RandomRange(-rad, rad)*FRACUNIT}
		local hei = (mo.height + mo.height/2)/FRACUNIT
		hei = P_RandomRange(0, $)*FRACUNIT
		local sparkle = P_SpawnMobjFromMobj(mo, pos[1], pos[2], hei, MT_BOXSPARKLE)
		sparkle.fuse = 30
		sparkle.frame = $|FF_FULLBRIGHT
		sparkle.scale = 1
		sparkle.destscale = FRACUNIT*2
		sparkle.cusval = 6090420
		sparkle.tracer = mo
	end
	
	-- Set our ghost mobj's properties
	if p.followitem == MT_NULL then p.followitem = MT_GHOST end
	if p.followmobj and p.followmobj.valid
		p.followmobj.color = SKINCOLOR_SUNGAZER
		p.followmobj.colorized = true
		p.followmobj.scale = mo.scale + (sin((leveltime%360)*ANG1*3)+FRACUNIT)/50
		p.followmobj.angle = mo.player and mo.player.drawangle or mo.angle
		p.followmobj.roll = mo.roll
		p.followmobj.pitch = mo.pitch
		p.followmobj.spriteroll = mo.spriteroll
		p.followmobj.sprite = mo.sprite
		p.followmobj.sprite2 = mo.sprite2
		p.followmobj.frame = mo.frame
		p.followmobj.tics = -1
		p.followmobj.frame = $ & ~FF_TRANSMASK
		p.followmobj.frame = $ |(tr_trans50<<FF_TRANSSHIFT)|FF_ADD|FF_TRANS70
		p.followmobj.renderflags = mo.renderflags
		p.followmobj.blendmode = mo.blendmode
		p.followmobj.fuse = 15
		p.followmobj.skin = mo.skin
		p.followmobj.spritexscale = mo.spritexscale
		p.followmobj.spriteyscale = mo.spriteyscale
	end
	
	p.thrustfactor = p.TRP.superFlight and 10 or 5

	p.TRP.flaming = (p.cmd.buttons & BT_SPIN)

	if (not p.TRP.flaming) and p.TRP.flameGas
		p.TRP.flameGas = $ - FRACUNIT/trip.FLAMEGAS
		if p.TRP.flameGas < 0 then p.TRP.flameGas = 0 end
	end

	-- Correcting starpost scale shenanigans
	if p.starpostscale and p.starpostscale ~= p.TRP.truesize
		p.starpostscale = p.TRP.truesize
	end
	
	p.TRP.lastState = p.mo.state
	
	-- Used to go back to normal when we lose our super form
	p.TRP.superReturn = true
end

-- Jump ability thinker for super trip
trip.SuperAbilityThinker = function(p)
	local mo = p.mo
	if (p.pflags & PF_JUMPSTASIS) or p.TRP.superFlight return end
	if P_IsObjectInGoop(mo) return end

	p.TRP.superFlight = true
	mo.state = p.speed > p.runspeed and S_PLAY_FLOAT_RUN or S_PLAY_FLOAT
	P_SetObjectMomZ(mo, 4*FRACUNIT)
	if not (mo.eflags & MFE_UNDERWATER)
		-- We'll spread some dust around us and do a distinct flapping sound for taking off, unless we're underwater
		S_StartSound(mo, sfx_ttako)
		local floordist = abs(mo.floorz - mo.z)
		local dustdist = 100
		if floordist < dustdist*FRACUNIT
			local multforce = FRACUNIT - floordist/dustdist
			S_StartSoundAtVolume(mo, sfx_kc31, 70 - (floordist/FRACUNIT) + 30)
			local addAngle = 0
			for i=1,16 do
				local dust = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_SPINDUST)
				dust.flags = $ & ~MF_NOCLIP
				P_SetOrigin(dust, dust.x, dust.y, mo.floorz + dust.height/2)
				dust.frame = $ + FF_TRANS50
				dust.angle = p.mo.angle + addAngle
				addAngle = $ + FixedAngle( 22 * FRACUNIT + FRACUNIT/2 )
				P_InstaThrust(dust, dust.angle, FixedMul(25*FRACUNIT, multforce) + 5*FRACUNIT )
				P_SetObjectMomZ(dust, FixedMul( P_RandomRange(1,3)*(FRACUNIT/3), multforce) )
				dust.scale = FixedMul(FRACUNIT/2, multforce) + FRACUNIT/2
			end
		end

	end
end

-- Grounded flame breath
trip.SuperSpinThinker = function(p)
	if not p.TRP.superFlight then FireBreath(p) end
end

-- Super music
local function SuperMusic(oldname, newname, flags, looping)
	if not consoleplayer return end
	if not consoleplayer.TSUPERMUS return end

	if newname == "_super"
		if (consoleplayer and skins[consoleplayer.skin].name == "trip")
		or (secondarydisplayplayer and skins[secondarydisplayplayer.skin].name == "trip")
			return "TRSUP"
		end
	end
end

-- Give trip a super flag when loading into a nights stage so her super form is properly announced at the end
local function DragonTripText()
	for p in players.iterate do
		if not p.valid continue end
		if skins[p.skin].name == "trip" and (maptol & TOL_NIGHTS)
			p.charflags = $|SF_SUPER
		end
	end
end

addHook("MusicChange", SuperMusic)
addHook("MapLoad", DragonTripText)